//
//  MainView.swift
//  ChatGPTApp
//
//  Created by Mohammad Azam on 3/15/23.
//

import SwiftUI
import OpenAISwift

struct MainView: View {
    
    @State private var chatText: String = ""
    let openAI = OpenAISwift(authToken: "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")
    
    @State private var answers: [String] = []
    
    private var isFormValid: Bool {
        !chatText.isEmptyOrWhiteSpace
    }
    
    private func performSearch() {
        openAI.sendCompletion(with: chatText, maxTokens: 500) { result in
            switch result {
                case .success(let success):
                    let answer = success.choices.first?.text.trimmingCharacters(in: .whitespacesAndNewlines) ?? ""
                    answers.append(answer)
                    
                case .failure(let failure):
                    print(failure)
            }
        }
    }
    
    var body: some View {
        VStack {
            
            List(answers, id: \.self) { answer in
                Text(answer)
            }
            
            Spacer()
            HStack {
                TextField("Search...", text: $chatText)
                    .textFieldStyle(.roundedBorder)
                Button {
                    // action
                    performSearch()
                } label: {
                    Image(systemName: "paperplane.circle.fill")
                        .font(.title)
                        .rotationEffect(Angle(degrees: 45))
                }.buttonStyle(.borderless)
                    .tint(.blue)
                    .disabled(!isFormValid)

            }
        }.padding()
    }
}

struct MainView_Previews: PreviewProvider {
    static var previews: some View {
        MainView()
    }
}
